function confirmDelete() {
	if ( window.confirm('Are you sure you want to delete selected items?') ) {
		return true;
	} else {
		return false;
	}
}
function changeHeight(idName, direction) {
	var max = 99;
	var min = 3;
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	var row = parseInt(obj.getAttribute("rows"));
	if (row > 0) {
		row = row + ( direction * 2);
		if (row < min) row = min;
		if (row > max) row = max;
		obj.setAttribute("rows", row);
		if (window.navigator.userAgent.indexOf('AppleWebKit') > -1) {
			var height = row * 1.1;
			obj.style.height = Array(height,'em').join('');
		}
	}
	return false;
}
function replaceEntity(str) {
	str = str.split("&").join("&amp;");
	str = str.split("<").join("&lt;");
	str = str.split(">").join("&gt;");
	str = str.split('"').join("&quot;");
	return(str);
}
function reverseEntity(str) {
	str = str.split("&quot;").join('"');
	str = str.split("&gt;").join(">");
	str = str.split("&lt;").join("<");
	str = str.split("&amp;").join("&");
	return(str);
}
function changeEntity(idName, mode) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	var txtConfirm = (mode) ? 'convert all charcters to entities in textarea.' : 'convert all entities to normal characters in texarea.';
	txtConfirm = Array(txtConfirm,"\n\nAre you sure?").join('');
	if (document.selection) { // WinIE
		obj.focus();
		var str = document.selection.createRange().text;
		if (str) {
			document.selection.createRange().text = (mode) ? replaceEntity(str) : reverseEntity(str);
		} else if (obj.value && confirm(txtConfirm)) {
			obj.value = (mode) ? replaceEntity(obj.value) : reverseEntity(obj.value);
		}
	} else if ( (obj.selectionEnd - obj.selectionStart) > 0 ) { // Mozilla
		var bgnPos = obj.selectionStart;
		var endPos = obj.selectionEnd;
		var bfrStr = obj.value.substring(0, bgnPos);
		var fcsStr = (mode) ? replaceEntity(obj.value.substring(bgnPos, endPos)) : reverseEntity(obj.value.substring(bgnPos, endPos));
		var difLen = fcsStr.length - (endPos - bgnPos);
		var aftStr = obj.value.substring(endPos, obj.value.length);
		obj.value = Array(bfrStr,fcsStr,aftStr).join('');
		obj.setSelectionRange(bgnPos,endPos + difLen);
	} else if (obj.value) { // Others
		if (confirm(txtConfirm)) {
			obj.value = (mode) ? replaceEntity(obj.value) : reverseEntity(obj.value);
		}
	}
	return false;
}
function addHtmlTag(idName, tag, option) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	var bgnTag = (!option) ? Array('<',tag,'>').join('') : Array('<',tag,' ',option,'>').join('');
	var endTag = Array('</',tag,'>').join('');
	if (document.selection) { // WinIE
		obj.focus();
		var str = document.selection.createRange().text;
		if (str) {
			document.selection.createRange().text = Array(bgnTag,str,endTag).join('');
		} else {
			obj.value = Array(obj.value,bgnTag,endTag).join('');
		}
	} else if ( (obj.selectionEnd - obj.selectionStart) > 0 ) { // Mozilla
		var bgnPos = obj.selectionStart;
		var endPos = obj.selectionEnd;
		var bfrStr = obj.value.substring(0, bgnPos);
		var fcsStr = Array(bgnTag,obj.value.substring(bgnPos, endPos),endTag).join('');
		var difLen = fcsStr.length - (endPos - bgnPos);
		var aftStr = obj.value.substring(endPos, obj.value.length);
		obj.value = Array(bfrStr,fcsStr,aftStr).join('');
		obj.setSelectionRange(bgnPos,endPos + difLen);
	} else { // Others
		obj.value = Array(obj.value,bgnTag,endTag).join('');
	}
	return false;
}
function addLink(idName) {
	var url = prompt('Please input URL to link', 'http://');
	if (url == null) return false;
	var option = Array('href="',url,'" target="_blank"').join('');
	addHtmlTag(idName, 'a', option);
}
function addImage(idName,val) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	if (val == '') return false;
	obj.value = Array(obj.value,'<img ',val,' />').join('');
	return false;
}
function showForm(idName) {
	var obj = this.document.getElementById(idName);
	if (!obj) return false;
	obj.style.display = 'block';
	window.location.hash = idName;
	var objForm = this.document.getElementById('upload_file');
	if (!objForm) return;
	objForm.focus();
	return;
}
function setNowTime() {
	var nowTime = new Date();
	var yr = nowTime.getYear();
	var mo = nowTime.getMonth()+1;
	var dy = nowTime.getDate();
	var ho = nowTime.getHours();
	var mi = nowTime.getMinutes();
	var sc = nowTime.getSeconds();
	var form = document.mainform;
	form.date_yr.value = (yr < 2000) ? yr + 1900 : yr;
	form.date_mo.value = (mo < 10) ? '0' + mo : mo;
	form.date_dy.value = (dy < 10) ? '0' + dy : dy;
	form.date_ho.value = (ho < 10) ? '0' + ho : ho;
	form.date_mi.value = (mi < 10) ? '0' + mi : mi;
	form.date_sc.value = (sc < 10) ? '0' + sc : sc;
	return;
}
function sbit(txt_subj,txt_url,txt_body) {
	if (txt_subj.length > 0) {
		var obj = this.document.getElementById('entry_title');
		obj.value = Array('Re: ',unescape(txt_subj)).join('');
	}
	if (txt_body.length > 0) {
		var obj = this.document.getElementById('entry_body');
		obj.value = Array(obj.value,'<blockquote><p>',unescape(txt_body),'</p></blockquote>').join('');
	}
	if (txt_url.length > 0 && txt_subj.length > 0) {
		var obj = this.document.getElementById('entry_body');
		obj.value = Array(obj.value,'<p class="source"><cite><a href="',unescape(txt_url),'">',unescape(txt_subj),'</a></cite></p>\n').join('');
	}
}
