#!/usr/bin/perl
# 
# library - text 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.13;
	# 
	# ver 0.00 [2003/09/20] 
	# ver 0.01 [2003/10/07] sbtxt_det ѹ֤δְ㤤 / С褦
	# ver 0.02 [2003/11/03] sbtxt_inscomma ɲ
	# ver 0.03 [2003/11/06] sbtxt_lfconv ɲ
	# ver 0.04 [2004/05/06] sbtxt_decform ɲ
	# ver 0.05 [2004/05/13] sbtxt_lfconv ˥Ѵɲ / sbtxt_remove_cdata, sbtxt_restore_cdata ɲ
	# ver 0.06 [2004/05/14] sbtxt_crypt ɲ / sbtxt_lfconv ΥХ
	# ver 0.07 [2004/06/21] sbtxt_urienc_utf8, sbtxt_uridec_utf8 ɲ
	# ver 0.08 [2004/07/23] sbtxt_decform ľ
	# ver 0.09 [2004/07/28] sbtxt_easy_encryption ɲ
	# ver 0.10 [2004/07/29] sbtxt_easy_encryption 㴳
	# ver 0.11 [2004/07/30] ѥǧڤɬԤХ
	# ver 0.12 [2004/08/15] sbtxt_clip_utf8 ΥХ
	# ver 0.13 [2004/08/17] sbtxt_sanitize_for_elem ɲ
}
sub sbtxt_decform { # form ǥɽ
	my ($text,$flag,$def) = @_; # ϥѥ᡼ / $flag : 1 ѴԤ, 2 ѴԤ
	my %aCharSet = ('euc-jp' => 'euc', 'shift_jis' => 'sjis', 'utf-8' => 'utf8', 'iso-2022-jp' => 'jis');
	$text =~ s/\x0D\x0A/\n/g;
	$text =~ tr/\x0D\x0A/\n\n/;
	if ($flag) {
		my $charset = '';
		if ($gIn{'charset'} eq '') {
			$charset = &sblang_checkcode($text);
			$charset = $def if ($charset ne 'euc' and $charset ne 'sjis' and $charset ne 'utf8' and $charset ne 'jis');
		} else {
			$charset = $aCharSet{lc($gIn{'charset'})};
		}
		$charset = $def if ($charset eq '');
		$text = &sblang_conv($text,$gEnv{'code'},$charset);
		$text = &sbtxt_ent($text);
		$text = &sbtxt_lfconv($text,0) if ($flag > 1);
	}
	return($text);
}
sub sbtxt_remove_cdata { # CDATA Ѵ
	my $text = shift;
	my $output = '';
	my $tail = $2 if ( $text =~ /(.*)\]\]\>(.*)/s );
	while ( $text =~ s/(.*?)<\!\[CDATA\[(.*?)\]\]\>//s ) {
		$output .= $1 . '&sbx;' . &sbtxt_ent($2);
	}
	$output .= $tail;
	return($output);
}
sub sbtxt_sanitize_for_elem {
	my $text = shift;
	if ($text ne '') {
		$text =~ s/:/&#58;/g;
		$text =~ s/\[/&#91;/g;
		$text =~ s/\]/&#93;/g;
		$text =~ s/\'/&#39;/g;
	}
	return($text);
}
sub sbtxt_restore_cdata { # CDATA 
	my $text = shift;
	if ($text =~ /^&sbx;/) {
		$text =~ s/^&sbx;//;
		$text = &sbtxt_det($text);
	}
	return($text);
}
sub sbtxt_ent { # ʸλȤؤѴ
	my $text = shift;
	$text =~ s/&/&amp;/g;
	$text =~ s/\"/&quot;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	return($text);
}
sub sbtxt_det { # ʸλȤѴ
	my $text = shift;
	$text =~ s/&gt;/>/g;
	$text =~ s/&lt;/</g;
	$text =~ s/&quot;/\"/g;
	$text =~ s/&amp;/&/g;
	return($text);
}
sub sbtxt_lfconv { # ԥѴ
	my ($text,$how) = @_; # ϥѥ᡼ / $how => 0:esc 1:unesc(\n) 2:unesc(<br>)
	my $aLineFeed = '%n';
	my $aBrTag    = '<br />';
	$how = 0 if ($how eq '');
	if ($how == 0) {
		while ($text =~ /\n$/) { # ʸԥɺ
			$text =~ s/\n$//g;
		}
		$text =~ s/%/%%/g;
		$text =~ s/\n/$aLineFeed/g;
	} else {
		my @lines = split($aLineFeed,$text);
		$text = '';
		foreach my $line (@lines) {
			my $cnt = ($line =~ tr/%/%/);
			$line .= ($cnt % 2) ? $aLineFeed : "\n";
			$text .= $line;
		}
		while ($text =~ /\n$/) { # ʸԥɺ
			$text =~ s/\n$//g;
		}
		$text =~ s/\n/$aBrTag\n/g if ($how == 2);
		$text =~ s/%%/%/g;
	}
	return($text);
}
sub sbtxt_rmvtag { # programed  by OHZAKI Hiroki // ϥƥȤ EUC ˽स륳ɤǤ뤳
	my ($str,$code) = @_;         # ϥѥ᡼
	my ($result);                 # ϥѥ᡼
	my ($tag_tmp,$text_tmp) = (); # ѥ᡼
	my ($text_regex_,$comment_tag_regex,$tag_regex,$text_regex) = (); # ɽѡ
	# ɽƥץ졼
	$tag_regex_ = q{[^"'<>]*(?:"[^"]*"[^"'<>]*|'[^']*'[^"'<>]*)*(?:>|(?=<)|$(?!\n))}; #'}}}}
	$comment_tag_regex = '<!(?:--[^-]*-(?:[^-]+-)*?-(?:[^>-]*(?:-[^>-]+)*?)??)*(?:>|$(?!\n)|--.*$)';
	$tag_regex = qq{$comment_tag_regex|<$tag_regex_};
	$text_regex = q{[^<]*};
	# Ѵ
	$str = &sblang_conv($str,'euc',$code) if ($code ne 'euc');
	while ($str =~ /($text_regex)($tag_regex)?/gso) {
		last if $1 eq '' and $2 eq '';
		$result .= $1;
		$tag_tmp = $2;
		if ($tag_tmp =~ /^<(XMP|PLAINTEXT|SCRIPT)(?![0-9A-Za-z])/i) {
			$str =~ /(.*?)(?:<\/$1(?![0-9A-Za-z])$tag_regex_|$)/gsi;
			($text_tmp = $1) =~ s/</&lt;/g;
			$text_tmp =~ s/>/&gt;/g;
			$result .= $text_tmp;
		}
	}
	$result = &sblang_conv($result,$code,'euc') if ($code ne 'euc');
	return($result);
}
sub sbtxt_clip { # ƥȤڤФ
	my ($text,$st,$len,$code) = @_; # ϥѥ᡼
	my ($out) = ();                 # ϥѥ᡼
	$text = &sblang_conv($text,'euc',$code) if ($code eq 'jis' or $code eq 'sjis');
	if ($code eq 'utf8') {
		$out = &sbtxt_clip_utf8($text,$st,$len);
	} elsif ($code ne 'iso') {
		if ($st > 0) { # ϰ֤η
			$out = substr($text,0,$st);
			if    ($out =~ /\x8F$/)                { $st = $st + 2; }
			elsif ($out =~ tr/\x8E\xA1-\xFE// % 2) { $st++; }
		}
		{ # ĹĴ
			$out = substr($text,$st,$len);
			if    ($out =~ /\x8F$/)                { $out = substr($text,$st,$len-1); }
			elsif ($out =~ tr/\x8E\xA1-\xFE// % 2) { $out = substr($text,$st,$len+1); }
		}
		$out = &sblang_conv($out,$code,'euc') if ($code eq 'jis' or $code eq 'sjis');
	} else {
		$out = substr($text,$st,$len);
	}
	return($out);
}
sub sbtxt_clip_utf8 { # ƥȤڤФ // ϥƥȤ utf-8 ˽स륳ɤǤ뤳
	my ($text,$st,$len) = @_; # ϥѥ᡼
	my ($out) = ();           # ϥѥ᡼
	if ($st > 0) { # ϰ֤η
		$out = substr($text,0,$st);
		ST: {
			$_ = $out;
			/[\x00-\x7F]$/                         , last ST;
			/[\xC0-\xFD]$/               and $st-- , last ST;
			/[\xE0-\xFD][\x80-\xBF]$/    and $st-=2, last ST;
			/[\xF0-\xFD][\x80-\xBF]{2}$/ and $st-=3, last ST;
		}
		$st = 0 if ($st < 0);
	}
	{ # ĹĴ
		$out = substr($text,$st,$len);
		if ($out !~ /[\x00-\x7F]$/) {
			$out =~ s/[\xC0-\xFD]$//;
			$out =~ s/[\xE0-\xFD][\x80-\xBF]$//;
			$out =~ s/[\xF0-\xFD][\x80-\xBF]{2}$//;
		}
	}
	return($out);
	#  : http://www.akatsukinishisu.net/itazuragaki/id/round_utf-8
}
sub sbtxt_clip_word { # ƥȤڤФʥñ̡
	my ($text,$word,$len) = @_; # ϥѥ᡼ / ƥ,ñ,Хȿ
	my ($out) = ();             # ϥѥ᡼
	my @words = split(/\s+/,$text);
	$word = (@words > $word) ? $word : @words;
	$out = join(' ', @words[0..$word-1]);
	$out = &sbtxt_clip($out,0,$len) if ($len and length($out) > $len);
	return($out);
}
sub sbtxt_urienc { # URI  programed by OHZAKI Hiroki
	my ($text) = @_; # ϥѥ᡼
	$str =~ s/(\W)/'%' . unpack('H2', $1)/eg;
	return($text);
}
sub sbtxt_uridec { # URI 󥨥 programed by OHZAKI Hiroki
	my ($text) = @_; # ϥѥ᡼
	$text =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2',$1)/eg;
	return($text);
}
sub sbtxt_urienc_utf8 {
	my ($text,$code) = @_; # ϥѥ᡼
	$text = &sblang_conv($text,'utf8',$code) if ($code ne 'utf8');
	$text =~ s/(\W)/'%' . unpack('H2', $1)/eg;
	return($text);
}
sub sbtxt_uridec_utf8 {
	my ($text,$code) = @_; # ϥѥ᡼
	$text =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2',$1)/eg;
	$text = &sblang_conv($text,$code,'utf8') if ($code ne 'utf8');
	return($text);
}
sub sbtxt_inscomma { # 롼 programed by OHZAKI Hiroki
	my ($num) = @_; #  ϥѥ᡼
	if ($num =~ /^[-+]?\d\d\d\d+/g) {
		for (my $i = pos($num) - 3, my $j = $num =~ /^[-+]/; $i > $j; $i -= 3) {
			substr($num, $i, 0) = ',';
		}
	}
	return($num);
}
sub sbtxt_findword { # ƥȸ롼 // ϥƥȤ EUC ˽स륳ɤǤ뤳
	my ($text,$word) = @_; # ϥѥ᡼
	my ($find) = ();       # ϥѥ᡼
	return() if ($] < 5.005); # perl 5.5 ʹߤΤб
	my $aEucBgn = qr{(?<!\x8F)};
	my $aEucEnd = qr{(?=(?:[\xA1-\xFE][\xA1-\xFE])*(?:[\x00-\x7F\x8E\x8F]|\z))}x;
	$find = ($text =~ /$aEucBgn\Q$word\E$aEucEnd/i) ? 1 : 0;
	return($find);
	#  : http://www.din.or.jp/~ohzaki/perl.htm#JP_Match
}
sub sbtxt_crypt { # ƥȰŹ沽
	my ($text) = @_; # ϥѥ᡼
	my $salt = '';
	my @tmps = ('a'..'z','A'..'Z','0'..'9','.','/');
	1 while (length($salt .= $tmps[rand(@tmps)]) < 8);
	$salt = '$1$' . $salt . '$' if (index(crypt('a','$1$a$'),'$1$a$') == 0);
	return(crypt($text,$salt));
}
sub sbtxt_easy_encryption { # ʰװŹ沽롼
	my ($pass,$key) = @_;
	my $out = '';
	my @aChar = ('a'..'z','A'..'Z','0'..'9','.','/','_');
	my $aMax  = @aChar;
	my %table = ();
	return($pass) if ($gEnv{'global'}{'secure_cook'} == 1);
	for (my $i=0;$i<$aMax;$i++) {
		$table{$aChar[$i]} = $i;
	}
	$key = 'b' if ($key eq 'a');
	my $num = $table{$key};
	my $len = length($pass);
	if (index($pass,'#') > -1) {
		$len--;
		for (my $i=0;$i<$len;$i++) {
			my $str = substr($pass,($i + 1),1);
			my $chk = (($i % 2) == 0) ? ($table{$str} - $num) % $aMax : ($table{$str} + $num) % $aMax;
			$out .= $aChar[$chk];
		}
	} else {
		$out .= '#';
		for (my $i=0;$i<$len;$i++) {
			my $str = substr($pass,$i,1);
			my $chk = (($i % 2) == 0) ? ($table{$str} + $num) % $aMax : ($table{$str} - $num) % $aMax;
			$out .= $aChar[$chk];
		}
	}
	return($out);
}
1;
